local e=require("simple-uci").cursor()
local o=e:get_all("network","wan")
local l=e:get_all("network","wan6")
local u=e:get_first("gluon-wan-dnsmasq","static")
local i=Form(translate("WAN connection"))
local t=i:section(Section)
local a=t:option(ListValue,"ipv4",translate("IPv4"))
a:value("dhcp",translate("Automatic (DHCP)"))
a:value("static",translate("Static"))
a:value("none",translate("Disabled"))
a.default=o.proto
local r=t:option(Value,"ipv4_addr",translate("IP address"))
r:depends(a,"static")
r.default=o.ipaddr
r.datatype="ip4addr"
local h=t:option(Value,"ipv4_netmask",translate("Netmask"))
h:depends(a,"static")
h.default=o.netmask or"255.255.255.0"
h.datatype="ip4addr"
local d=t:option(Value,"ipv4_gateway",translate("Gateway"))
d:depends(a,"static")
d.default=o.gateway
d.datatype="ip4addr"
t=i:section(Section)
local o=t:option(ListValue,"ipv6",translate("IPv6"))
o:value("dhcpv6",translate("Automatic (RA/DHCPv6)"))
o:value("static",translate("Static"))
o:value("none",translate("Disabled"))
o.default=l.proto
local n=t:option(Value,"ipv6_addr",translate("IP address"))
n:depends(o,"static")
n.default=l.ip6addr
n.datatype="ip6addr"
local s=t:option(Value,"ipv6_gateway",translate("Gateway"))
s:depends(o,"static")
s.default=l.ip6gw
s.datatype="ip6addr"
if u then
t=i:section(Section)
local t=t:option(DynamicList,"dns",translate("Static DNS servers"))
t.default=e:get_list("gluon-wan-dnsmasq",u,"server")
t.datatype="ipaddr"
t.optional=true
function t:write(t)
e:set_list("gluon-wan-dnsmasq",u,"server",t)
e:commit("gluon-wan-dnsmasq")
end
end
t=i:section(Section)
local l={
["/wan"]=translate("WAN Interfaces"),
["/single"]=translate("Interface"),
["/lan"]=translate("LAN Interfaces")
}
e:foreach('gluon','interface',function(a)
local o=a['.name']
local t=t:option(MultiListValue,o,l[a.name]or a.name)
t.orientation='horizontal'
t:value('uplink','Uplink')
t:value('mesh','Mesh')
t:value('client','Client')
t:exclusive('uplink','client')
t:exclusive('mesh','client')
t.default=a.role
function t:write(t)
e:set_list("gluon",o,"role",t)
end
end)
local l
e:foreach("system","gpio_switch",function(t)
if t[".name"]:match("poe")then
if not l then
l=i:section(Section)
end
local o={
["^PoE Power Port(%d*)$"]=function(e)return translatef("Enable PoE Power Port %s",e[1])end,
["^PoE Passthrough$"]=function()return translate("Enable PoE Passthrough")end,
}
local a
for e,o in pairs(o)do
local e={t.name:match(e)}
if e[1]then
a=o(e)
break
end
end
if not a then
a=translatef('Enable "%s"',t.name)
end
local a=l:option(Flag,t[".name"],a)
a.default=e:get_bool("system",t[".name"],"value")
function a:write(a)
e:set("system",t[".name"],"value",a)
end
end
end)
function i:write()
e:set("network","wan","proto",a.data)
if a.data=="static"then
e:set("network","wan","ipaddr",r.data)
e:set("network","wan","netmask",h.data)
e:set("network","wan","gateway",d.data)
else
e:delete("network","wan","ipaddr")
e:delete("network","wan","netmask")
e:delete("network","wan","gateway")
end
e:set("network","wan6","proto",o.data)
if o.data=="static"then
e:set("network","wan6","ip6addr",n.data)
e:set("network","wan6","ip6gw",s.data)
else
e:delete("network","wan6","ip6addr")
e:delete("network","wan6","ip6gw")
end
e:commit('gluon')
e:commit("network")
e:commit('system')
end
return i
